//Quadify Poles Ver. 1.1
//by Steven Pettit
//03 Sept 2015

@script modeler
@warnings off
@name Quadify Poles

main
{
	m_polys = nil;
	my_sel = nil;
	pnts_a = nil;
	pnts_b = nil;
	
	plysel = @0,0@;
    idx = 0;
	pcnt = 0;
	my_pole = 0;
	plycnt = 0;
	i = 0;
	j = 0;
	
    selmode(DIRECT);
	
	//Let's Grab a point, and grab the polygons it's a part of.
	pcnt = pointcount();
	if (pcnt < 1) error("Select a pole point!");
	editbegin();
		my_pole = points[1];
	editend();
	
	//Get it's polygons and select them.
	selmode(USER);
	undogroupbegin();
	my_sel = my_pole.polygon();
	selpoint(CLEAR);
	selpolygon(CLEAR);
	selpolygon(SET, POLYID, my_sel);
	plycnt = my_sel.count();
    
    editbegin();
        m_polys = polygons;
		//I don't want to deal with wrapping a value, so...
		// I add the first value to the end of the list.
		m_polys += polygons[1];
			
		//I need to sort the polygons, so they are adjacent to each other...
		for(i=1;i<=plycnt;i++){
			//Get the point IDs for polygon[i]
			pnts_a = nil;
			pnts_a = getpolypts(m_polys[i], my_pole);
			for(j=i+1; j <= m_polys.count(); j++){
				//Get the point IDs on the polygon we're testing
				pnts_b = nil;
				pnts_b = getpolypts(m_polys[j],my_pole);
				if( adjacent_test(pnts_a,pnts_b) && ( j != (i+1))){
					//We've got an adjacent polygon that is not adjacent in the list
					//So, we'll swap them, and break out of the loop.
					tmp = m_polys[i+1];
					m_polys[i+1] = m_polys[j];
					m_polys[j] = tmp;
					j = m_polys.count() + 1;
				}
			}
		}
	editend();
    	
    idx = 1;
    max = plycnt - 1;
    while(idx <= max)
    {
        plysel[1] = m_polys[idx];
        plysel[2] = m_polys[idx+1];
        selpolygon(CLEAR);
        selpolygon(SET,POLYID,plysel);     
        mergepols();
        idx += 2;
    }
 	undogroupend();
	selpolygon(CLEAR);
}

rot: qA
{
	//Rotate Left for an array of 3 elements.
	tmp = qA[1];
	qA[1] = qA[2];
	qA[2] = qA[3];
	qA[3] = tmp;
	return(qA);
}

getpolypts: qA, qP
{
	//Get's the point IDs for polygon qA, and rotates point ID qP
	//(the pole point ID) into the first index - that makes the
	//adjacency test simpler to code.
	
	retv = nil;
	k = 0;
	for(k=1;k <= qA.pointCount;k++) retv += qA.points[k];
	while(retv[1] != qP) { retv = rot(retv); }
	return(retv);
}

adjacent_test: qA, qB
{
	//Simple Adjacency Test, to see if qA and qB share a common
	//point besides the pole, which is index 1 of both arrays.
	//qA and qB are arrays of point IDs.
	//returns TRUE if at least 1 point is shared, false otherwise.
	
	retv = false;
	retv = ((qA[2] == qB[2]) || (qA[2] == qB[3]));
	retv = retv || ((qA[3] == qB[2]) || (qA[3] == qB[3]));
	return(retv);
}