/*Weld Average Pairs, aka Stitch
  Verson 2.0
  by Steven Pettit, 04 Feb 2020
  It works with symmetry now.*/

@warnings
@script modeler
@name Stitch

main
{
    var i = 0;
	var j = 0;
	//Get Symmetry State
	//0 = Off, 1 = On
	var symm = getmode("SYMMETRY");
	var stp = 2 + (2 * symm);
	var skew = 1 + symm;
    var newPnt = <0, 0, 0>; 
    selmode(DIRECT);
    var pntcnt = pointcount();
	//Trap the errors!
    if(pntcnt == 0) error("No Points Selected!");
	if(pntcnt < 2) error("Not enough points selected!");
    if((pntcnt % 2) != 0) error("Need an even amount of points!");
	if(((pntcnt % 4) != 0) && symm) error("Need a multiple of 4 points!");
	//begin the welding!
	undogroupbegin();
    editbegin();
		//This could be handled better, but it works.
		for(i = 1; i < pntcnt; i += stp){
			for(j=0; j<=symm; j++){
				newPnt = (pointinfo(points[i+j]) + pointinfo(points[i+j+skew])) / <2,2,2>;
				pointmove(points[i+j],newPnt);
				pointmove(points[i+j+skew],newPnt);
			}
		}
    editend();
	//Kill the duplicates, if they match each other exactly
	mergepoints();
	undogroupend();
}
