/* Weld Pairs v 2.0
   by Steven Pettit, 04 Feb 2020
   Works with Symmetry */

@script modeler
@warnings off
@name Weld Pairs

main
{
    //debug();
	var i = 0;
	var j = 0;
	//Get Symmetry State
	//0 = Off, 1 = On
	var symm = getmode("SYMMETRY");
	var stp = 2 + (2 * symm);
	var skew = 1 + symm;
     pnta = <0, 0, 0>;
    selmode(DIRECT);
    pntCnt = pointcount();
	//Trap the errors!
    if(pntcnt == 0) error("No Points Selected!");
	if(pntcnt < 2) error("Not enough points selected!");
    if((pntcnt % 2) != 0) error("Need an even amount of points!");
	if(((pntcnt % 4) != 0) && symm) error("Symmetry - Need at least 2 pairs!");
	//begin the welding!
	undogroupbegin();
    editbegin();
		for(i = 1; i < pntcnt; i += stp){
			for(j=0; j<=symm; j++){
				newPnt = pointinfo(points[i+j+skew]);
				pointmove(points[i+j],newPnt);
			}
		}
    editend();
	//Kill the duplicates, if they match each other exactly
	mergepoints();
	undogroupend();
}




